//
// Copyright © 2022 Nevis Security AG. All rights reserved.
//

import Flutter
import NevisMobileAuthentication

struct ListenForOsCredentialsMethodHandler: MethodHandler {
	func execute(using _: MobileAuthenticationClient, with message: ChannelInMessage, result: @escaping FlutterResult) throws {
		let message: ListenForOsCredentialsMessage = try validate(message: message)
		let operation: UserInteractionOperation = try OperationCache.shared.read(by: message.operationId)
		guard let state = operation.state as? VerifyUserState else {
			throw PluginError.illegalState("Verify User state is expected!")
		}

		guard case .biometric = state.verificationMode else {
			throw PluginError.illegalState("ListenForOsCredentials can be only called during biometric authentication!")
		}

		state.biometricUserVerificationHandler?.verify()
		result(EmptyResultMessage())
	}
}
