//
// Copyright © 2022 Nevis Security AG. All rights reserved.
//

import NevisMobileAuthentication

class LocalAccountsResultMessage: ChannelResultMessage {
	// MARK: Properties

	let accounts: [any Account]

	// MARK: Initialization

	init(accounts: [any Account]) {
		self.accounts = accounts
		super.init()
	}

	// MARK: Encodable

	enum AccountCodingKeys: String, CodingKey {
		case username
	}
	
	override func encode(to encoder: Encoder) throws {
		var container = encoder.container(keyedBy: ResultMessageCodingKeys.self)
		var resultContainer = container.nestedUnkeyedContainer(forKey: .result)
		try accounts.forEach {
			var accountContainer = resultContainer.nestedContainer(keyedBy: AccountCodingKeys.self)
			try accountContainer.encode($0.username, forKey: .username)
		}
		
		try super.encode(to: encoder)
	}
}
