// Copyright © 2022 Nevis Security AG. All rights reserved.

import 'authenticator_test_data.dart';
import 'common_test_data.dart';

class SelectAccountTestData {
  static final typedContextMap = {
    'operationId': CommonTestData.operationId,
    'accounts': [
      {'username': CommonTestData.username1},
      {'username': CommonTestData.username2}
    ],
    'authenticators': [AuthenticatorTestData.typedAuthenticator1Map],
    'transactionConfirmationData': 'asd'
  };

  static final correctArguments = {
    'operationId': CommonTestData.operationId,
    'context': typedContextMap,
  };

  static final wrongArguments = {
    'operationId': CommonTestData.wrongId,
    'context': {
      'operationId': CommonTestData.wrongId,
      'accounts': [
        {'username': CommonTestData.username1},
        {'username': 'testUsername2'}
      ],
      'authenticators': [
        {
          'operationId': CommonTestData.wrongId,
          'aaid': CommonTestData.aaid1,
          'isSupportedByHardware': true,
          'registration': {
            'registeredAccounts': [
              {'username': CommonTestData.username1},
              {'username': CommonTestData.username2}
            ]
          },
          'userEnrollment': {
            'type': 'UnknownUserEnrollment',
            'data': {
              'enrolledAccounts': [
                {'username': CommonTestData.username1}
              ]
            },
          },
        }
      ],
      'transactionConfirmationData': 'asd'
    }
  };

  static final wrongIdArguments = {
    'operationId': CommonTestData.wrongId,
    'context': {
      'operationId': CommonTestData.wrongId,
      'accounts': [
        {'username': CommonTestData.username1},
        {'username': CommonTestData.username2}
      ],
      'authenticators': [
        {
          'operationId': CommonTestData.wrongId,
          'aaid': CommonTestData.aaid1,
          'isSupportedByHardware': true,
          'registration': {
            'registeredAccounts': [
              {'username': CommonTestData.username1},
              {'username': CommonTestData.username2}
            ]
          },
          'userEnrollment': {
            'type': 'SdkUserEnrollment',
            'data': {
              'enrolledAccounts': [
                {'username': CommonTestData.username1}
              ]
            },
          },
        }
      ],
      'transactionConfirmationData': 'asd'
    }
  };
}
